type chan = int Event.channel

let new_channel : unit -> chan = Event.new_channel

type event = int Event.event

let send : chan -> int -> unit = fun ic i ->
  Event.sync (Event.send ic i)

let receive : chan -> int = fun ic ->
  Event.sync (Event.receive ic)

let create_thread =
  fun f v ->
    print_int v ; print_newline () ;
    Thread.create f v

let m = Mutex.create ()

let rec create_filter inchan number =
  let next = ref None in (* prochain filtre déjà créé ou pas *)
  let next_th = ref None in
  let continue = ref true in
  let next_n = ref 0 in
    while !continue do
      let n = receive inchan in
	if n = -1 then continue := false;
        if n mod number = 0 then
          ()
        else
          match !next with
            | None ->
		if n = -1 then
		  ()
		else
		  begin
                    let c = new_channel () in
                      next := Some c;
                      next_th := Some (create_thread (create_filter c) n);
		      next_n := n;
		  end
            | Some c ->
                send c n;
    done;
    match !next_th with
      | None ->
(*
	  flush stdout;
	  Printf.printf "Termination of %d\n"number;
	  flush stdout;
*)
	Mutex.unlock m
      | Some th ->
(*
	  flush stdout;
	  Printf.printf "Termination of %d, waiting for %d\n" number !next_n;
	  flush stdout;
*)
(*	  Thread.join th*)
()
(*
	  Printf.printf "Termination of %d, Ok for %d\n" number !next_n;
	  flush stdout
*)

let generator outchan =
  for i = 2 to 9000 do
      send outchan i
  done;
  send outchan (-1)

let () =
  let () = Mutex.lock m in
  let c = new_channel () in
  let t1 = Thread.create generator c in
  let t2 = Thread.create (create_filter c) 2 in
    Thread.join t1 ;
    Thread.join t2 ;
    Mutex.lock m
