
let rec intervalle r a b =
  if a > b then r
  else intervalle2 (a::r) (a+1) b

and intervalle2 r a b =
  if a > b then []
  else intervalle (a::r) (a+1) b

let intervalle a b = intervalle [] a b 


module SafeThread :
sig
  type t
  val create : ('a -> 'b) -> 'a -> t
  val join : t -> unit
end =
  Thread


let f size v   = 
  print_string "debut du thread\n"; print_newline();
  for i = 0 to size - 1 
  do
    v.(i) <- i;
    ignore(intervalle 0 (10_000 + (i*i) mod 10_000))
  done;
  print_string "fin du thread\n"; print_newline();
  ()

let check size i v  = 
  if i > 0 && i < size then
    if v.(i) = v.(i-1) + 1 then ()
    else 
     ( print_string "Echec de la verification a l'index : ";
        print_int i;
        print_newline();
        assert false
     )
  else ()

let _ =
  let size = 10_000 in
  let v1 = Array.make size 0 in
  let v2 = Array.make size 0 in
  let v3 = Array.make size 0 in
  let v4 = Array.make size 0 in
  let v5 = Array.make size 0 in
  let () = print_endline "Create threads" in

  let lv = [|v1;v2;v3;v4;v5|] in 
  let lth = Array.map (SafeThread.create (f size)) lv in 
     print_string "passage de la barrire des creations";
     print_newline();
  let lwj = Array.iter SafeThread.join lth in 
    print_string "passage de la barrire des joints";
    print_newline();
     
  let lch = Array.iteri (check size) lv in 
    print_string "passage de la barrire des verifications";
    print_newline();
    ();


    print_endline "intervalle 0 1000 : start";
    for i = 0 to 100_000 do
      ignore(intervalle 0 1000);
    done;
    print_endline "intervalle 0 1000 : end"; 
    print_endline "Exit !"
